#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "Odds2_DayBuff.h"
#include "FileEncrypt.h"
std::auto_ptr<Odds2_DayBuff> Odds2_DayBuff::msSingleton(nullptr);

int Odds2_DayBuff::GetCount()
{
	return (int)mMapData.size();
}

const Odds2_DayBuffData* Odds2_DayBuff::GetData(int BuffID)
{
	auto it = mMapData.find(BuffID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, Odds2_DayBuffData>& Odds2_DayBuff::GetMapData()
{
	return mMapData;
}

void Odds2_DayBuff::Reload()
{
	mMapData.clear();
	Load();
}

void Odds2_DayBuff::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Odds2_DayBuffData data;
		data.mBuffID = element->IntAttribute("BuffID");
		data.mDay = element->IntAttribute("Day");
		data.mBuffEffectMin = element->IntAttribute("BuffEffectMin");
		data.mBuffEffectMax = element->IntAttribute("BuffEffectMax");
		if (mMapData.find(data.mBuffID) != mMapData.end())std::cout <<"data refind:" << data.mBuffID << std::endl;
		assert(mMapData.find(data.mBuffID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mBuffID, data));
		element = element->NextSiblingElement();
	}
}

void Odds2_DayBuff::Load()
{
	Load("../Config/Odds2_DayBuff.xml");
}

Odds2_DayBuff* Odds2_DayBuff::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Odds2_DayBuff());
	}
	return msSingleton.get();
}
